/* 
 * python-qwt. Python wrapper for the Qwt Widget Library
 * Copyright (C) 1997   Josef Wilgen
 * Copyright (C) 2002   Uwe Rathmann
 * Copyright (C) 2015   Gudjon I. Gudjonsson
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the Qwt License, Version 1.0
 *****************************************************************************/
class QwtAbstractSeriesStore
{
%TypeHeaderCode
#include "qwt_series_store.h"
%End
protected:
    virtual ~QwtAbstractSeriesStore();
    virtual void dataChanged();
    virtual void setRectOfInterest( const QRectF & );
    virtual QRectF dataRect() const;
    virtual size_t dataSize() const;
//private:
//    QwtAbstractSeriesStore();
};

template<T>
class QwtSeriesStore: QwtAbstractSeriesStore
{
%TypeHeaderCode
#include "qwt_series_store.h"
%End
public:
    QwtSeriesStore<T>();
    //QwtSeriesStoreQwtIntervalSample();
    ~QwtSeriesStore<T>();
    void setData( QwtSeriesData<T> /TransferThis/ *series );
    QwtSeriesData<T> *data();
    //const QwtSeriesData *data() const;
    T sample( int index ) const;
    virtual size_t dataSize() const;
    virtual QRectF dataRect() const;
    virtual void setRectOfInterest( const QRectF &rect );
    QwtSeriesData<T> *swapData( QwtSeriesDataQwt<T> *series );
};
